# FoundationClasses
TKAdvTools
Expr

# Expr_NamedUnknown Class Reference

This class describes any variable of an expression.
Assignment is treated directly in this class.
.

`#include <Expr_NamedUnknown.hxx>`

Inheritance diagram for Expr_NamedUnknown:

[legend]

## Public Member Functions

Standard_EXPORT | Expr_NamedUnknown (const TCollection_AsciiString &name)
Standard_Boolean | IsAssigned () const
| Tests if an expression is assigned to <me>. .
Standard_EXPORT const Handle_Expr_GeneralExpression & | AssignedExpression () const
| If exists, returns the assigned expression. An exception is raised if the expression does not exist. .
Standard_EXPORT void | Assign (const Handle(Expr_GeneralExpression)&exp)
| Assigns <me> to <exp> expression. Raises exception if <exp> refers to <me>. .
void | Deassign ()
| Supresses the assigned expression .
Standard_EXPORT Standard_Integer | NbSubExpressions () const
| Returns the number of sub-expressions contained in <me> ( >= 0) .
Standard_EXPORT const Handle_Expr_GeneralExpression & | SubExpression (const Standard_Integer I) const
| Returns the -th sub-expression of <me> raises OutOfRange if > NbSubExpressions(me) .
Standard_EXPORT Handle_Expr_GeneralExpression | Simplified () const
| Returns a GeneralExpression after replacement of NamedUnknowns by an associated expression and after values computation. .
Standard_EXPORT Handle_Expr_GeneralExpression | ShallowSimplified () const
| Returns a GeneralExpression after a simplification of the arguments of <me>. .
Standard_EXPORT Handle_Expr_GeneralExpression | Copy () const
| Returns a copy of <me> having the same unknowns and functions. .
Standard_EXPORT Standard_Boolean | ContainsUnknowns () const
| Tests if <me> contains NamedUnknown. .
Standard_EXPORT Standard_Boolean | Contains (const Handle(Expr_GeneralExpression)&exp) const
| Tests if <exp> is contained in <me>. .
Standard_EXPORT Standard_Boolean | IsLinear () const
| Tests if <me> is linear on every NamedUnknown it contains. .
Standard_EXPORT Handle_Expr_GeneralExpression | Derivative (const Handle(Expr_NamedUnknown)&X) const
| Returns the derivative on <x> unknown of <me> .
Standard_EXPORT void | Replace (const Handle(Expr_NamedUnknown)&var, const Handle(Expr_GeneralExpression)&with)
| Replaces all occurences of with <with> in <me> Raises InvalidOperand if <with> contains <me>. .
Standard_EXPORT Standard_Real | Evaluate (const Expr_Array1OfNamedUnknown &vars, const TColStd_Array1OfReal &vals) const
| Returns the value of <me> (as a Real) by replacement of <vars> by <vals>. Raises NotEvaluable if <me> contains NamedUnknown not in <vars> or NumericError if result cannot be computed. .
Standard_EXPORT const | Handle (Standard_Type)&DynamicType() const

## Private Attributes

Handle_Expr_GeneralExpression | myExpression

## Constructor & Destructor Documentation

Standard_EXPORT Expr_NamedUnknown::Expr_NamedUnknown | ( | const TCollection_AsciiString & | name | ) |

## Member Function Documentation

Standard_EXPORT void Expr_NamedUnknown::Assign | ( | const Handle(Expr_GeneralExpression)& | exp | ) |

Standard_EXPORT const Handle_Expr_GeneralExpression& Expr_NamedUnknown::AssignedExpression | ( |  | ) | const

Standard_EXPORT Standard_Boolean Expr_NamedUnknown::Contains | ( | const Handle(Expr_GeneralExpression)& | exp | ) | const`[virtual]`

| Implements Expr_GeneralExpression.

Standard_EXPORT Standard_Boolean Expr_NamedUnknown::ContainsUnknowns | ( |  | ) | const`[virtual]`

| Implements Expr_GeneralExpression.

Standard_EXPORT Handle_Expr_GeneralExpression Expr_NamedUnknown::Copy | ( |  | ) | const`[virtual]`

| Implements Expr_GeneralExpression.

void Expr_NamedUnknown::Deassign | ( |  | ) | `[inline]`

Standard_EXPORT Handle_Expr_GeneralExpression Expr_NamedUnknown::Derivative | ( | const Handle(Expr_NamedUnknown)& | X | ) | const`[virtual]`

| Implements Expr_GeneralExpression.

Standard_EXPORT Standard_Real Expr_NamedUnknown::Evaluate | ( | const Expr_Array1OfNamedUnknown & | vars,
|  | const TColStd_Array1OfReal & | vals
| ) | const`[virtual]`

| Implements Expr_GeneralExpression.

Standard_EXPORT const Expr_NamedUnknown::Handle | ( | Standard_Type |  | ) | const

| Reimplemented from Expr_NamedExpression.

Standard_Boolean Expr_NamedUnknown::IsAssigned | ( |  | ) | const`[inline]`

Standard_EXPORT Standard_Boolean Expr_NamedUnknown::IsLinear | ( |  | ) | const`[virtual]`

| Implements Expr_GeneralExpression.

Standard_EXPORT Standard_Integer Expr_NamedUnknown::NbSubExpressions | ( |  | ) | const`[virtual]`

| Implements Expr_GeneralExpression.

Standard_EXPORT void Expr_NamedUnknown::Replace | ( | const Handle(Expr_NamedUnknown)& | var,
|  | const Handle(Expr_GeneralExpression)& | with
| ) | `[virtual]`

| Implements Expr_GeneralExpression.

Standard_EXPORT Handle_Expr_GeneralExpression Expr_NamedUnknown::ShallowSimplified | ( |  | ) | const`[virtual]`

| Implements Expr_GeneralExpression.

Standard_EXPORT Handle_Expr_GeneralExpression Expr_NamedUnknown::Simplified | ( |  | ) | const`[virtual]`

| Implements Expr_GeneralExpression.

Standard_EXPORT const Handle_Expr_GeneralExpression& Expr_NamedUnknown::SubExpression | ( | const Standard_Integer | I | ) | const`[virtual]`

| Implements Expr_GeneralExpression.

## Field Documentation

Handle_Expr_GeneralExpression Expr_NamedUnknown::myExpression `[private]`

The documentation for this class was generated from the following files:

- Expr_NamedUnknown.hxx
- Expr_NamedUnknown.lxx